CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to build an e-commerce cart in Angular

Building a robust e-commerce cart is a fundamental requirement for any online storefront, yet managing state effectively across multiple components can often become complex. As the creator of CoreUI, I have architected numerous enterprise-level e-commerce systems using Angular since its early versions. From my expertise, the most efficient and modern solution for Angular applications is to leverage a singleton service combined with Angular Signals for reactive state management. This approach ensures that your cart data is synchronized across the entire application without the overhead of heavy state management libraries.

Use an Angular service with signal and computed to manage the cart state globally and reactively.

import { Injectable, signal, computed } from '@angular/core'

export interface CartItem {
  id: number
  name: string
  price: number
  quantity: number
  image: string
}

@Injectable({
  providedIn: 'root'
})
export class CartService {
  private cartItems = signal<CartItem[]>([])

  // Computed signal for the total number of items
  cartCount = computed(() => 
    this.cartItems().reduce((acc, item) => acc + item.quantity, 0)
  )

  // Computed signal for the total price
  totalPrice = computed(() => 
    this.cartItems().reduce((acc, item) => acc + (item.price * item.quantity), 0)
  )

  getCart() {
    return this.cartItems.asReadonly()
  }

  addToCart(product: CartItem) {
    this.cartItems.update(items => {
      const existing = items.find(i => i.id === product.id)
      if (existing) {
        return items.map(i => i.id === product.id 
          ? { ...i, quantity: i.quantity + 1 } 
          : i
        )
      }
      return [...items, { ...product, quantity: 1 }]
    })
  }

  removeItem(id: number) {
    this.cartItems.update(items => items.filter(i => i.id !== id))
  }

  updateQuantity(id: number, quantity: number) {
    if (quantity <= 0) {
      this.removeItem(id)
      return
    }
    this.cartItems.update(items => 
      items.map(i => i.id === id ? { ...i, quantity } : i)
    )
  }
}

This implementation utilizes a singleton service to hold the cart’s state using the signal primitive. By using computed signals, we automatically derive values like the total item count and the total price whenever the underlying cartItems signal changes. The addToCart method checks for existing items to increment quantity instead of creating duplicates, while updateQuantity and removeItem provide standard management functions. This architecture is highly performant because Angular only updates the specific parts of the DOM that depend on these signals, making it ideal for large-scale production apps.

Implementing the Product Card

To display products that users can add to the cart, we can use the CoreUI Card component to create a clean, professional look.

import { Component, Input, inject } from '@angular/core'
import { CurrencyPipe } from '@angular/common'
import { CardModule, ButtonModule, GridModule } from '@coreui/angular'
import { CartService, CartItem } from './cart.service'

@Component({
  selector: 'app-product-card',
  standalone: true,
  imports: [CurrencyPipe, CardModule, ButtonModule, GridModule],
  template: `
    <c-card style="width: 18rem;">
      <img cCardImg="top" [src]="product.image" [alt]="product.name">
      <c-card-body>
        <h5 cCardTitle>{{ product.name }}</h5>
        <p cCardText>{{ product.price | currency }}</p>
        <button cButton color="primary" (click)="addToCart()">
          Add to Cart
        </button>
      </c-card-body>
    </c-card>
  `
})
export class ProductCardComponent {
  @Input({ required: true }) product!: CartItem
  private cartService = inject(CartService)

  addToCart() {
    this.cartService.addToCart(this.product)
  }
}

Creating the Cart Table View

For the checkout or cart summary page, we utilize the CoreUI Table component to list the items and allow for quantity adjustments.

import { Component, inject } from '@angular/core'
import { CommonModule } from '@angular/common'
import { TableModule, ButtonModule, FormModule } from '@coreui/angular'
import { CartService } from './cart.service'

@Component({
  selector: 'app-cart-list',
  standalone: true,
  imports: [CommonModule, TableModule, ButtonModule, FormModule],
  template: `
    <table cTable hover>
      <thead>
        <tr>
          <th>Product</th>
          <th>Price</th>
          <th>Quantity</th>
          <th>Subtotal</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
        <tr *ngFor="let item of cartItems()">
          <td>{{ item.name }}</td>
          <td>{{ item.price | currency }}</td>
          <td>
            <input cFormControl type="number" 
                   [value]="item.quantity" 
                   (change)="updateQty(item.id, $event)">
          </td>
          <td>{{ (item.price * item.quantity) | currency }}</td>
          <td>
            <button cButton color="danger" variant="outline" 
                    (click)="remove(item.id)">
              Remove
            </button>
          </td>
        </tr>
      </tbody>
    </table>
  `
})
export class CartListComponent {
  private cartService = inject(CartService)
  cartItems = this.cartService.getCart()

  updateQty(id: number, event: Event) {
    const val = parseInt((event.target as HTMLInputElement).value, 10)
    this.cartService.updateQuantity(id, val)
  }

  remove(id: number) {
    this.cartService.removeItem(id)
  }
}

Handling Cart Summary and Totals

The final piece is a summary component that displays the total cost. This is where we leverage the computed signals from our service for real-time updates.

import { Component, inject } from '@angular/core'
import { CommonModule } from '@angular/common'
import { CardModule, ButtonModule } from '@coreui/angular'
import { CartService } from './cart.service'

@Component({
  selector: 'app-cart-summary',
  standalone: true,
  imports: [CommonModule, CardModule, ButtonModule],
  template: `
    <c-card class="mb-4">
      <c-card-body>
        <h5 cCardTitle>Order Summary</h5>
        <div class="d-flex justify-content-between mb-2">
          <span>Items:</span>
          <span>{{ cartCount() }}</span>
        </div>
        <div class="d-flex justify-content-between fw-bold border-top pt-2">
          <span>Total:</span>
          <span>{{ totalPrice() | currency }}</span>
        </div>
        <button cButton color="success" class="w-100 mt-3">
          Proceed to Checkout
        </button>
      </c-card-body>
    </c-card>
  `
})
export class CartSummaryComponent {
  private cartService = inject(CartService)
  cartCount = this.cartService.cartCount
  totalPrice = this.cartService.totalPrice
}

Persisting Cart State

In a real-world scenario, you want the cart to survive page refreshes. You can easily extend the CartService to use localStorage within an effect.

import { effect } from '@angular/core'

// Inside CartService constructor
constructor() {
  const saved = localStorage.getItem('cart_data')
  if (saved) {
    this.cartItems.set(JSON.parse(saved))
  }

  effect(() => {
    localStorage.setItem('cart_data', JSON.stringify(this.cartItems()))
  })
}

Best Practice Note:

Using Signals for e-commerce carts is significantly more efficient than using Observables for simple UI state, as it removes the need for manual subscription management and pipe transformations. This is the same pattern we recommend in CoreUI templates for building scalable Angular Dashboard Templates where data consistency is paramount. For formatting the final prices, you might want to look at how to format a number as currency in JavaScript to ensure localized precision. If you are just starting your project, ensure you know how to create a new Angular project with the latest standalone component defaults.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
What is the difference between typeof and instanceof in JavaScript
What is the difference between typeof and instanceof in JavaScript

How to conditionally add attributes to React components
How to conditionally add attributes to React components

How to force a React component to re-render
How to force a React component to re-render

What are the three dots `...` in JavaScript do?
What are the three dots `...` in JavaScript do?

CoreUI ONE — 250+ PRO components and 25+ admin templates for React, Angular, Vue, Bootstrap and Next.js, plus Data Grid, Scheduler, 4,300+ PRO icons and the Next.js boilerplate. One license. → See what you get

How to build an e-commerce cart in React

Building a reliable e-commerce cart in React requires a solid understanding of state management and component composition. As the creator of CoreUI, I have architected countless e-commerce systems that scale from simple prototypes to high-traffic production environments.

The most efficient approach involves using the React Context API to manage global cart state, ensuring that product data remains synchronized across your entire application. By leveraging modern hooks and robust UI components, we can create a seamless shopping experience that is both performant and easy to maintain.

Use React Context to manage a global cart state and provide functions for adding, removing, and updating product quantities.

1. Creating the Cart Context and Provider

The foundation of any React shopping cart is a centralized state. We use the Context API to avoid “prop drilling” and make the cart data accessible to any component, whether it is a navigation bar showing the item count or a checkout page.

import React, { createContext, useContext, useState, useEffect } from 'react'

const CartContext = createContext()

export const CartProvider = ({ children }) => {
  const [cartItems, setCartItems] = useState([])

  // Load cart from localStorage on mount
  useEffect(() => {
    const savedCart = localStorage.getItem('coreui-cart')
    if (savedCart) setCartItems(JSON.parse(savedCart))
  }, [])

  // Persist cart changes
  useEffect(() => {
    localStorage.setItem('coreui-cart', JSON.stringify(cartItems))
  }, [cartItems])

  return (
    <CartContext.Provider value={{ cartItems, setCartItems }}>
      {children}
    </CartContext.Provider>
  )
}

export const useCart = () => useContext(CartContext)

This code sets up the CartProvider which wraps your application. It initializes the state with an empty array and uses useEffect to synchronize the cart with the browser’s localStorage. This ensures that the user’s selections are preserved even if they refresh the page or return later.

2. Implementing the Add to Cart Functionality

To add items, we need a function that checks if a product already exists in the cart. If it does, we increment the quantity; otherwise, we append the new product. This logic follows the standard pattern for how to add an item to an array in JavaScript.

import { useCart } from './CartContext'

const ProductCard = ({ product }) => {
  const { cartItems, setCartItems } = useCart()

  const addToCart = () => {
    const existingItem = cartItems.find((item) => item.id === product.id)
    
    if (existingItem) {
      setCartItems(
        cartItems.map((item) =>
          item.id === product.id 
            ? { ...item, quantity: item.quantity + 1 } 
            : item
        )
      )
    } else {
      setCartItems([...cartItems, { ...product, quantity: 1 }])
    }
  }

  return (
    <div className='product-item'>
      <h3>{product.name}</h3>
      <button onClick={addToCart}>Add to Cart</button>
    </div>
  )
}

This approach ensures immutability by creating a new array instead of modifying the existing one. If the item is already present, we use map to update only the specific item’s quantity, keeping the rest of the cart intact.

3. Managing Item Quantities and Removal

A functional cart must allow users to adjust quantities or remove items entirely. For removal, we use the filter method, which is the idiomatic way how to remove a specific item from an array in JavaScript.

const updateQuantity = (id, amount) => {
  setCartItems((prevItems) =>
    prevItems.map((item) => {
      if (item.id === id) {
        const newQuantity = Math.max(1, item.quantity + amount)
        return { ...item, quantity: newQuantity }
      }
      return item
    })
  )
}

const removeFromCart = (id) => {
  // Use filter to exclude the item with the matching ID
  setCartItems(cartItems.filter((item) => item.id !== id))
}

The updateQuantity function uses Math.max(1, ...) to prevent the quantity from dropping below one. The removeFromCart function demonstrates how to filter an array in JavaScript to create a new version of the cart without the unwanted product.

4. Calculating Totals and Formatting Currency

Calculating the total cost involves iterating through the cartItems array and summing the product of price and quantity. To ensure a professional look, we must format the number as currency.

const CartSummary = () => {
  const { cartItems } = useCart()

  const subtotal = cartItems.reduce(
    (acc, item) => acc + item.price * item.quantity, 
    0
  )

  const formatPrice = (amount) => {
    return new Intl.NumberFormat('en-US', {
      style: 'currency',
      currency: 'USD'
    }).format(amount)
  }

  return (
    <div className='cart-summary'>
      <p>Total Items: {cartItems.length}</p>
      <h4>Total: {formatPrice(subtotal)}</h4>
    </div>
  )
}

Using reduce is the most efficient way to calculate a single value from an array of objects. The Intl.NumberFormat API provides a localized and reliable way to display prices to your users.

5. Building the UI with CoreUI Components

To make the cart look professional and responsive, we utilize CoreUI components like CCard, CTable, and CButton. This ensures a consistent design system that is accessible and mobile-friendly.

import { 
  CCard, CCardBody, CTable, CTableHead, 
  CTableRow, CTableHeaderCell, CTableBody, 
  CTableDataCell, CButton 
} from '@coreui/react'

const CartTable = () => {
  const { cartItems, removeFromCart, updateQuantity } = useCart()

  return (
    <CCard>
      <CCardBody>
        <CTable align='middle' responsive>
          <CTableHead>
            <CTableRow>
              <CTableHeaderCell>Product</CTableHeaderCell>
              <CTableHeaderCell>Quantity</CTableHeaderCell>
              <CTableHeaderCell>Price</CTableHeaderCell>
              <CTableHeaderCell>Action</CTableHeaderCell>
            </CTableRow>
          </CTableHead>
          <CTableBody>
            {cartItems.map((item) => (
              <CTableRow key={item.id}>
                <CTableDataCell>{item.name}</CTableDataCell>
                <CTableDataCell>
                  <CButton onClick={() => updateQuantity(item.id, -1)}>-</CButton>
                  <span className='mx-2'>{item.quantity}</span>
                  <CButton onClick={() => updateQuantity(item.id, 1)}>+</CButton>
                </CTableDataCell>
                <CTableDataCell>${item.price * item.quantity}</CTableDataCell>
                <CTableDataCell>
                  <CButton color='danger' onClick={() => removeFromCart(item.id)}>
                    Remove
                  </CButton>
                </CTableDataCell>
              </CTableRow>
            ))}
          </CTableBody>
        </CTable>
      </CCardBody>
    </CCard>
  )
}

Using the CoreUI Table component allows you to quickly build complex data layouts with built-in styling. The CButton components provide interactive elements that follow our design guidelines for a polished user experience.

Best Practice Note:

When building e-commerce carts, always treat your state as immutable to avoid difficult-to-track bugs. In CoreUI components, we prioritize predictable data flow by using functional updates in useState. Additionally, always validate product availability on the server side before finalizing a checkout, as client-side state can be manipulated by users. For production apps, consider using a specialized library like Redux Toolkit if your cart logic becomes significantly more complex, though Context API is perfectly sufficient for most e-commerce use cases.


Speed up your responsive apps and websites with fully-featured, ready-to-use open-source admin panel templates—free to use and built for efficiency.


About the Author

Subscribe to our newsletter
Get early information about new products, product updates and blog posts.
Vue.js Forge
Vue.js Forge

How to create a single page application using React.js
How to create a single page application using React.js

React v18.0 – finally is of legal age?
React v18.0 – finally is of legal age?

Quo Vadis Vue.js
Quo Vadis Vue.js